﻿import flash.display.BitmapData;
import flash.geom.Rectangle;
import flash.geom.Matrix;
import flash.geom.ColorTransform;
import flash.display.PixelSnapping;


class jp.nipx.effect.BlurZoom{
	
	
	public function BlurZoom( container:MovieClip, zoom:Number, offsetX:Number, offsetY:Number, quality:Number ){
		this._rect	= new Rectangle();
		
		
		
		this.container	= container;
		this._zoom	= ( zoom != undefined ) ? zoom : 0;
		this._offsetX	= ( offsetX != undefined ) ? offsetX : 0.5;
		this._offsetY	= ( offsetY != undefined ) ? offsetY : 0.5;
		this._quality	= ( quality != undefined ) ? quality : 5;
		
		this._bmp = this.container.createEmptyMovieClip( "_bmp", this.container.getNextHighestDepth() );
		this.render();
	}
	
	public var container:MovieClip;
	
	private var _bmp:MovieClip;
	private var _bitmapData:BitmapData;
	private var _rect:Rectangle;
	private var _distance:Number = 0;
	
	private var _zoom:Number;
	public function get zoom():Number{
		return this._zoom;
	}
	public function set zoom(n:Number):Void{
		this._zoom	= n;
		this.render();
	}
	
	private var _offsetX:Number;
	public function get offsetX():Number{
		return this._offsetX;
	}
	public function set offsetX(n:Number):Void{
		this._offsetX = n;
		this.render();
	}
	
	private var _offsetY:Number;
	public function get offsetY():Number{
		return this._offsetY;
	}
	public function set offsetY(n:Number):Void{
		this._offsetY = n;
		this.render();
	}
	
	private var _quality:Number;
	public function get quality():Number{
		return this._quality;
	}
	public function set quality(n:Number):Void{
		this._quality = n;
		this.render();
	}
	
	private var _alpha:Number = 1;
	public function get alpha():Number{
		return this._alpha;
	}
	public function set alpha(n:Number):Void{
		this._alpha = n;
		this._bmp._alpha = this._alpha * 100;
	}
	
	
	
	public function render():Void{
		this._bmp._visible = false;
		if( this._zoom == 0 ) return;
		
		
		var rect:Object	= this.container.getRect( this.container );
			rect.left = ( 0<rect.xMin ) ? 0 : rect.xMin;
			rect.top  = ( 0<rect.yMin ) ? 0 : rect.yMin;
		
		var width:Number	= rect.xMax - rect.left;
		var height:Number	= rect.yMax - rect.top;
		
		if( this._rect.equals( rect ) ){
			this._bitmapData.fillRect( this._rect, 0x00000000 );
		}
		else{
			this._bitmapData.dispose();
			this._bitmapData = new BitmapData( width, height, true, 0xffffffff );
			var a:Number = Math.sqrt( Math.pow( width, 2 ) + Math.pow( height, 2 ) );
			var b:Number = a + 1;
			this._distance = b / a - 1;
		}
		
		var tx:Number = ( 0<rect.left) ? 0 : -rect.left;
		var ty:Number = ( 0<rect.top ) ? 0 : -rect.top;
		
		this._bitmapData.draw( this.container, new Matrix( 1, 0, 0, 1, tx, ty ) );
		
		for( var i:Number=1; i<this._zoom; i++ ){
			var s:Number	= 1 + ( this._distance * this._quality ) * i;
			var x:Number	= ( width  * s - width )  * this.offsetX;
			var y:Number	= ( height * s - height ) * this.offsetY;
			
			this._bitmapData.draw( this.container, new Matrix( s, 0, 0, s, tx - x, ty - y ), new ColorTransform( 1, 1, 1, 1/this._zoom, 0, 0, 0, 0 ), null, null, false )
		}
		
		this._bmp.attachBitmap( this._bitmapData,this._bmp.getNextHighestDepth() );
		this._bmp._x = -tx;
		this._bmp._y = -ty;
		this._bmp._visible = true;
	}
	
	
	
	
}